const electron = require('electron')

const { app, BrowserWindow, shell } = require('electron')

const fs = require("fs");
if(require('electron-squirrel-startup')) return;


// 保持对window对象的全局引用，如果不这么做的话，当JavaScript对象被
// 垃圾回收的时候，window对象将会自动的关闭
let win
let userWin
const Menu = electron.Menu
const ipc = electron.ipcMain
//登录窗口最小化
ipc.on('window-min',function(){
  win.minimize();
})
//登录窗口最大化
ipc.on('window-max',function(){
  if(mainWindow.isMaximized()){
    win.restore();  
  }else{
    win.maximize(); 
  }
})
ipc.on('window-close',function(){
  win.close();
})
ipc.on('open-url', (event, url) => {
  shell.openExternal(url);
});
ipc.on('open-user',function(){
  userWin = new BrowserWindow({
    width: 1200,
    height: 700,
    frame: false,
    webPreferences: {
      nodeIntegration: true
    },
    maximizable: true,
    minimizable: true,
    resizable: true
    //,icon: '../callwin/images/logo.ico'
  })
  
  userWin.loadFile('user.html')
  //userWin.loadURL('https://e.xiaohuatong.cn/main/index.html')
  //userWin.webContents.openDevTools()
  ipc.on('user-back',function(){
    userWin.webContents.goBack();
  })
  ipc.on('user-forward',function(){
    console.log(userWin.webContents);
  })
  ipc.on('user-min',function(){
    userWin.minimize();
  })
  ipc.on('user-max',function(){
    if(userWin.isMaximized()){
      userWin.restore();
    }else{
      userWin.maximize();
    }
  })
  ipc.on('user-close',function(){
    userWin.close();
  })
  ipc.on('user-login',function(){
    var data = { 'autoLog': '0' };
    data = JSON.stringify(data);
    fs.writeFile('autolog.txt', data, function(err) {
        if (err) {
            console.log(err);
        }
    });
    createWindow();
    userWin.close();
  })
  win.close();
})
function createWindow () {
  Menu.setApplicationMenu(null)
  // 创建浏览器窗口。
  win = new BrowserWindow({
    width: 600,
    height: 420,
    frame: false,
    webPreferences: {
      nodeIntegration: true
    },
    resizable: false
    //,icon: '../callwin/images/logo.ico'
  })

  // 加载index.html文件
  win.loadFile('index.html')

  // 打开开发者工具
  // win.webContents.openDevTools()

  // 当 window 被关闭，这个事件会被触发。
  win.on('closed', () => {
    // 取消引用 window 对象，如果你的应用支持多窗口的话，
    // 通常会把多个 window 对象存放在一个数组里面，
    // 与此同时，你应该删除相应的元素。
    win = null
  })

  // win.setProgressBar(0.5)

  win.once('focus', () => win.flashFrame(false))
  win.flashFrame(true)
}

// Electron 会在初始化后并准备
// 创建浏览器窗口时，调用这个函数。
// 部分 API 在 ready 事件触发后才能使用。
app.on('ready', createWindow)

// 当全部窗口关闭时退出。
app.on('window-all-closed', () => {
  // 在 macOS 上，除非用户用 Cmd + Q 确定地退出，
  // 否则绝大部分应用及其菜单栏会保持激活。
  if (process.platform !== 'darwin') {
    app.quit()
  }
})

app.on('activate', () => {
  // 在macOS上，当单击dock图标并且没有其他窗口打开时，
  // 通常在应用程序中重新创建一个窗口。
  if (win === null) {
    createWindow()
  }
})

app.setUserTasks([
  {
    program: process.execPath,
    arguments: '--new-window',
    iconPath: process.execPath,
    iconIndex: 0,
    title: 'New Window',
    description: 'Create a new window yes'
  }
])

// 在这个文件中，你可以续写应用剩下主进程代码。
// 也可以拆分成几个文件，然后用 require 导入。